{-

SPS/APS - Security Protocol Specification langauge
Copyright Omar Saad Almousa, Technical Univerity of Denmark (DTU) 2013-2015

All Rights Reserved.

-}
module ToTheory where
---------------------------------------------------------
thy [] ="" --stdTheory
thy (x:z) = oneThy x ++ thy z
--------------------------------------------------------- 
oneThy a@(name,fieldTypes)= "\n%Auto-generated by APS\n%Formats Theory Section\n"++
                                "Theory Format_"++name++":"++
                                "\n\nSignature:\n\n\n"++ name++"/"++ show(n)++   ", "++sig name n ++
                                "\n\nCancellation:\n"++ canc name n n ++
                                -- "\nTopdec:\n\n\n"++ topDec name n ++
                                "\n\nAnalysis:\n\n\ndecana"++ ana name n
                            where n= length fieldTypes
---------------------------------------------------------
sig name 1= name++"get1/1" 
sig name n= sig name (n-1) ++", "++name++"get"++show(n)++"/1"  
---------------------------------------------------------
canc name 1 l= "\n\n"++name++"get1("++name++"(" ++ xXs l ++"))= X1\n"
canc name n l= canc name (n-1) l++ "\n\n"++name++"get"++show(n)++"("++name++"(" ++ xXs l ++"))= X"++show(n)++"\n"
---------------------------------------------------------
xXs 1= "X1"
xXs l=xXs (l-1) ++", "++ "X"++show(l)
---------------------------------------------------------
--     decana(pair(X1,X2))=[]->[X1,X2]
ana name n = "("++name++"("++xXs n++"))=[]->["++xXs n++"]"
---------------------------------------------------------
stdTheory = ""
-- "\n\n%% OFMC - Algebraic Theories\n%%\n%% Author Sebastian Moedersheim\n\nTheory StdAsymEnc:\n"++
				-- "% Standard Asymetric Encryption\nSignature:\n\n\ninv/1,crypt/2\n\nCancellation:\n\n\n"++
				-- "crypt(inv(X1),crypt(X1,X2)) = X2\n\n\ninv(inv(X1)) = X1\n\n"++
				-- "Analysis:\n\n\ndecana(crypt(inv(X1),X2))=[X1]->[X2]\n\n\ndecana(crypt(X1,X2)) | X1/=inv(X3) =[inv(X1)]->[X2]"++
				-- " Theory StdSymEnc:\n  % Standard Symmetric Encryption\n  Signature:\n    scrypt/2\n"++
				-- "Cancellation:\n    scrypt(X1,scrypt(X1,X2)) = X2\n  Analysis:\n    "++
				-- "decana(scrypt(X1,X2))=[X1]->[X2] \nTheory Concatenation:\n  % Concatenation/Pairing\n" ++
				-- "  % This operator is associative which can be changed \n   "++
				-- "% by simply commenting-out the entire topdec-section.\n"++  
				-- "Signature: \n    fst/1, snd/1, pair/2\n   Cancellation:\n"++
				-- "fst(pair(X1,X2)) = X1\n    snd(pair(X1,X2)) = X2\n"++
				-- " Topdec:\n   % pair(pair(Z1,Z2),T2)=pair(Z1,pair(Z2,T2))\n    topdec(pair,pair(T1,T2))=\n      [T1,T2]\n"++
				-- "      if T1==pair(Z1,Z2){\n        [Z1,pair(Z2,T2)]} \n  Analysis:\n    decana(pair(X1,X2))=[]->[X1,X2]\n"++
				-- "\n\nTheory Arithmetic:\n  Signature:\n    add/2, neg/1, zero/0,\n    mult/2, minv/1, one/0,\n    exp/2 \n"++ 
				-- "Cancellation:\n    add(X,neg(X))=zero\n    add(X,zero)=X\n    add(add(X,Y),neg(Y))=X\n    mult(X,minv(X))=one\n"++
				-- "mult(X,one)=X\n    mult(mult(X,Y),minv(Y))=X\n  Topdec:\n    % add is associative and commutative:\n"++
				-- "    topdec(add,add(T1,T2))=\n      [T1,T2]\n      [T2,T1]\n      if T1==add(Z1,Z2){\n        [Z1,add(Z2,T2)]\n"++
				-- "                 [add(Z1,T2),Z2]\n        if T2==add(Z3,Z4){\n"++
				-- "[add(Z1,Z3),add(Z2,Z4)]}}\n      if T2==add(Z1,Z2){\n"++
				-- " [add(T1,Z1),Z2]\n    [Z1,add(T1,Z2)]}\n     "++
				-- "% mult is associative and commutative:\n    topdec(mult,mult(T1,T2))=\n"++
				-- "[T1,T2]\n      [T2,T1]\n      if T1==mult(Z1,Z2){\n        [Z1,mult(Z2,T2)]\n        [mult(Z1,T2),Z2]\n"++
				-- "        if T2==mult(Z3,Z4){\n          [mult(Z1,Z3),mult(Z2,Z4)]}}\n      if T2==mult(Z1,Z2){\n"++
				-- "        [mult(T1,Z1),Z2]\n        [Z1,mult(T1,Z2)]}\n    % Distributivity:\n"++
				-- "mult(X1,add(X2,X3))=add(mult(X1,X2),mult(X1,X3))\n     topdec(add,mult(X1,X2))=\n      if X2==add(X3,X4){\n"++
				-- "         [mult(X1,X3),mult(X1,X4)]}\n%    topdec(mult,add(X1,X2))=\n%      if X1==mult(X3,X4){\n"++
				-- "%        if X2==mult(X3,X5){\n%          [X3,mult(X4,X5)]}}\n    % Relation between exp,mult and add:\n "++
				-- "% exp(exp(X1,X2),X3)=exp(X1,mult(X2,X3))\n    % exp(X1,sum(X2,X3))=mult(exp(X1,X2),exp(X1,X3))\n"++
				-- "    topdec(exp,exp(T1,T2))=\n      [T1,T2]\n      if T1==exp(Z1,Z2){\n       [Z1,mult(T2,Z2)]\n"++
				-- "       [exp(Z1,T2),Z2]}\n      if T2==mult(Z1,Z2){\n       [exp(T1,Z1),Z2]}\n    topdec(mult,exp(T1,T2))=\n"++
				-- "      if T2==sum(Z1,Z2){\n      [exp(T1,Z2),exp(T1,Z2)]}\n  Analysis:\n    decana(add(X1,X2)) =[X1]->[X2]\n"++
				-- "    decana(mult(X1,X2))=[X1]->[X2]\n    decana(exp(X1,X2)) =[X2]->[X1]\n    decana(neg(X))=[]->[X]\n"++
				-- "    decana(minv(X))=[]->[X]\nTheory Xor:\n  % Bitwise exclusive or.\n  Signature:\n    e/0, \n"++
				-- "    xor/2\n  Cancellation:\n    xor(xor(X1,X1),X2) = X2\n    xor(X1,X1) = e\n    xor(X1,e)  = X1\n"++
				-- "  Topdec:\n  % xor is associative and commutative\n   topdec(xor,xor(T1,T2))=\n     [T1,T2]\n"++
				-- "     [T2,T1]\n     if T1==xor(Z1,Z2){\n       [Z1,xor(Z2,T2)]\n       [xor(Z1,T2),Z2]\n"++
				-- "			if T2==xor(Z3,Z4){\n         [xor(Z1,Z3),xor(Z2,Z4)]}}\n     if T2==xor(Z1,Z2){\n"++
				-- "       [xor(T1,Z1),Z2]\n       [Z1,xor(T1,Z2)]}\n  Analysis:\n    decana(xor(X1,X2))= \n     [X1]->[X2] \n"++
				-- "      %[xor(X1,X3)]->[xor(X2,X3)]\nTheory Skey:\n  % Symmetric key table\n"++
				-- "% Mind the underscore in the 'skey_', which means that this \n  % operator is not intruder-accessible. \n"++
				-- "  Signature:\n    skey_/2\n  Topdec:\n   % skey_(A,B) = skey_(B,A)\n    topdec(skey_,skey_(A,B))=\n"++
				-- "  Cancellation:\n    commitment(bind(M),open(M))=M\n  Analysis:\n    decana(bind(M)) = [open(M)] -> [M]\n\n"++
				-- "       [A,B]\n       [B,A]\nTheory Commit:\n  Signature:\n    bind/1,open/1,commitment/2\n"
---------------------------------------------------------